###############################################################################
# BizDesign ImageFolio Lite Edition 4.2 (Four-dot-Two)
###############################################################################
#
#          ##          ###        VERSION       :  4.2
#        ####        ##   ##      RELEASED ON   :  02/15/2007
#      ##  ##              ##     LAST MODIFIED :  02/15/2007
#    ##########          ##       
#          ##   ###    ##         
#          ##   ###  ########     
#
###############################################################################
# Released by BizDesign, Inc.
# written by Dirk Koppers and Greg Raaum of BizDesign
#
# Purchasing :  http://imagefolio.com/purchase/
# Support    :  http://imagefolio.com/support/
# Phone      :  (214) 642-9787
# Email      :  sales@bizdesign.com
###############################################################################
# COPYRIGHT AND LICENSE INFORMATION :
#
# Copyright (c) 1999-2007 BizDesign, Inc. All rights reserved.
#
# Selling or distributing the code for this program without prior written
# consent is expressly forbidden.
#
# One licensed copy of the program may reside on a single server, in use by a
# single domain.  For each installed instance of the program, a separate
# license is required.
#
# Licensed users may alter or modify this software, at their own risk, of
# course.  They may also hire others to modify their own copy of the code, as
# long as the code is not transferred to or retained by the individual who is
# hired (unless he/she is also a license holder). Although license-holders
# may modify the code for their use, modified code may NOT be resold or
# distributed.
#
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL BIZDESIGN,
# INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# BizDesign, Inc. is not liable for any conduct associated with image gallery
# activity, nor for any binary media posted using this program, including but
# not imited to images, photographs, movies, and clipart.
#
# The user must assume the entire risk of using the program.  Although this
# program has been thoroughly tested on BizDesign's servers, BizDesign does not
# warrant that it works on all servers and will not be held liable for anything,
# including but not limited to, misusage, error, or loss of data.  ANY
# LIABILITY OF THE SELLER WILL BE LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT
# OR REFUND OF PURCHASE PRICE.  Use at your own risk!
###############################################################################
# Do not modify below this line unless you know what you are doing.
###############################################################################

###############################################################################
# Error
# shows error message if form not filled out correctly
###############################################################################

sub Error{

   local ($whoops) = @_;

   if (!-e "$skin_dir/config_skin.pl") {
      require "$libpath/default_skin.pl";
   }
   else {
      if ($COOKIE{'if_skin'}) {
         $custom_skin_name = $COOKIE{'if_skin'};
      }
      elsif ($config_skin_name ne $skin_name) {
         $custom_skin_name = $skin_name;
      }
      else {
         $custom_skin_name = $config_skin_name;
      }
      if ($config_skin_name ne $custom_skin_name) {
         $skin_name = $custom_skin_name;
         if (-e "$base_skin_dir/$skin_name/config_skin.pl") {
            $skin_dir = $base_skin_dir . "/" . $skin_name;
            $skin_url = $base_skin_url . "/" . $skin_name;
            require "$skin_dir/config_skin.pl";
         }
         else {
            require "$skin_dir/config_skin.pl";
         }
      }
      else {
         require "$skin_dir/config_skin.pl";
      }
   }

print "Content-type: text/html\n\n";

print qq|
<html>
<head>
<title>Error</title>
<script language="JavaScript">
<!--
function help(){
window.alert("Help\\n\\nThis error message is displayed either because I was not able to understand your input or your input was incorrect.");
}
//-->
</script>

</head>

<body bgcolor="$body_bgcolor" marginwidth=0 marginheight=0 topmargin=0 leftmargin=0>

<form>

<table border=0 cellspacing=0 cellpadding=0 width="100%" height="100%">
  <tr>
    <td valign=middle align=center>
      <table border=0 cellspacing=1 cellpadding=0 width="350" bgcolor="$main_table_border_color">
        <tr>
          <td>
            <table border=0 cellspacing=0 cellpadding=4 width="350">
              <tr bgcolor="$main_header_bgcolor">
                <td nowrap><$cat_font><strong>Error!</strong></font></td>
                <td align=right nowrap><INPUT TYPE="button" VALUE=" ? " onClick="help()">&nbsp;<INPUT TYPE="button" VALUE=" X " onClick="history.go(-1)"></td>
              </tr>
              <tr bgcolor="$table_background_color">
                <td colspan=2>
                  <table border=0 cellspacing=0 cellpadding=5 width="100%">
                    <tr>
                      <td>
                        <$font><font size=2><b>$whoops</b><br><br>
                        If the button below does not take you back, please use your browser's 
                        back button to go back and try again.<br></font></font><br>
                      </td>
                    </tr>
                  </table>
                  <center>
                  <INPUT TYPE="button" VALUE="     OK     " onClick="history.go(-1)">
                  </center>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>
|;
$binary_image = (); # Needed for win32 to remove the tempfile
exit;
}

1;